package com.huyi.task.taskMan.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.huyi.task.base.entity.SysCompany;
import com.huyi.task.base.entity.SysCompanyRel;
import com.huyi.task.base.entity.SysCompanySpare;
import com.huyi.task.base.service.ISysCompanyRelService;
import com.huyi.task.base.service.ISysCompanyService;
import com.huyi.task.base.service.ISysCompanySpareService;
import com.tianhu.common.core.utils.CommonUtil;
import com.tianhu.common.core.utils.DateUtils;
import com.tianhu.common.core.utils.IdUtils;
import com.tianhu.common.core.web.controller.BaseController;
import com.tianhu.common.security.service.TokenService;
import lombok.SneakyThrows;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Configuration      //1.主要用于标记配置类，兼备Component的效果。
@EnableScheduling   // 2.开启定时任务
public class TimedTaskController extends BaseController {
    private static final Logger log = LoggerFactory.getLogger(TimedTaskController.class);

    @Autowired
    private TokenService tokenService;
    @Autowired
    private ISysCompanySpareService iSysCompanySpareService;
    @Autowired
    private ISysCompanyRelService iSysCompanyRelService;
    @Autowired
    private ISysCompanyService iSysCompanyService;

    /**
     * 定时查询周报未填
     */
    @SneakyThrows
    @Scheduled(cron = "0 */10 * * * ?")
    private void companyRelHandle(){
        LambdaQueryWrapper<SysCompanySpare> spareLambdaQueryWrapper = new LambdaQueryWrapper<>();
        spareLambdaQueryWrapper.eq(SysCompanySpare::getScpStatus,"00");
        List<SysCompanySpare> spareList = iSysCompanySpareService.findSysCompanySpares(spareLambdaQueryWrapper);
        List<String> companyList = CommonUtil.getIdFromList(spareList, "scpCompanyId");
        LambdaQueryWrapper<SysCompany> queryWrapper = new LambdaQueryWrapper<>();
        queryWrapper.eq(SysCompany::getScyStatus,"00");
        queryWrapper.in(SysCompany::getScyId,companyList);
        List<SysCompany> list = iSysCompanyService.findSysCompanys(queryWrapper);
//        if (list.size() > 0) {
//            for (int j = 0; j < list.size(); j++) {
//                //获取企业
//                String scyId = list.get(j).getScyId();
//                //获取企业Id
//                String panyId = weeklyList.get(j).get("ss_company_id") + "";
//                PmWeeklyInf weeklyInf = new PmWeeklyInf();
//                //主键
//                weeklyInf.setPwiId(IdUtils.fastSimpleUUID());
//                //企业Id
//                weeklyInf.setPwiCompanyId(panyId);
//                //员工Id
//                weeklyInf.setPwiStaffId(staffId);
//                //周报开始时间
//                weeklyInf.setPwiStartDate(addStartDate);
//                //周报结束时间
//                weeklyInf.setPwiEndDate(addEndDate);
//                //状态（未填）
//                weeklyInf.setPwiWriteState("02");
//                //状态（保存）
//                weeklyInf.setPwiState("01");
//                this.iPmWeeklyInfService.insertPmWeeklyInf(weeklyInf);
//            }
//        } else {
//            return;
//        }
    }

}

